package promo

import (
	"github.com/gin-gonic/gin"
	"github.com/perfect-panel/server/internal/logic/admin/promo"
	"github.com/perfect-panel/server/internal/svc"
	"github.com/perfect-panel/server/internal/types"
	"github.com/perfect-panel/server/pkg/result"
)

func GetRuleDetailHandler(svcCtx *svc.ServiceContext) func(c *gin.Context) {
	return func(c *gin.Context) {
		var req types.GetPromoRuleDetailRequest
		if err := c.ShouldBindUri(&req); err != nil {
			result.ParamErrorResult(c, err)
			return
		}
		if err := svcCtx.Validate(&req); err != nil {
			result.ParamErrorResult(c, err)
			return
		}
		l := promo.NewGetRuleDetailLogic(c.Request.Context(), svcCtx)
		resp, err := l.GetRuleDetail(&req)
		result.HttpResult(c, resp, err)
	}
}
